"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = exports.ModWorkletProcessor = void 0;
var Protracker_1 = require("./Protracker");
var ModWorkletProcessor = /** @class */ (function (_super) {
    __extends(ModWorkletProcessor, _super);
    function ModWorkletProcessor(_a) {
        var numberOfInputs = _a.numberOfInputs, numberOfOutputs = _a.numberOfOutputs, processorOptions = _a.processorOptions;
        var _this = this;
        var buffer = processorOptions.buffer, ext = processorOptions.ext, options = processorOptions.options;
        _this = _super.call(this) || this;
        switch (ext) {
            case "mod":
                _this.player = new Protracker_1.Protracker();
                break;
            // case "s3m":
            //   player = new Screamtracker();
            //   break;
            // case "xm":
            //   player = new Fasttracker();
            //   break;
            default:
                throw new Error("Unsupported file extension ".concat(ext));
        }
        if (_this.player.parse(buffer)) {
            _this.player.initialize();
            _this.player.flags = 1 + 2;
            if (options === null || options === void 0 ? void 0 : options.repeat) {
                _this.player.repeat = true;
            }
            if (options === null || options === void 0 ? void 0 : options.autoplay) {
                _this.player.play();
            }
        }
        else {
            throw new Error("Unable to parse buffer");
        }
        return _this;
    }
    ModWorkletProcessor.prototype.process = function (inputs, outputs, parameters) {
        var bufs = [outputs[0][0], outputs[0][1]];
        var buflen = outputs[0][0].length;
        this.player.mix(bufs, buflen);
        return true;
    };
    return ModWorkletProcessor;
}(AudioWorkletProcessor));
exports.ModWorkletProcessor = ModWorkletProcessor;
function register() {
    registerProcessor("ModWorkletProcessor", ModWorkletProcessor);
}
exports.register = register;
