export declare class Protracker {
    playing: boolean;
    paused: boolean;
    repeat: boolean;
    filter: boolean;
    mixval: number;
    syncqueue: number[];
    samplerate: number;
    baseperiodtable: Float32Array;
    finetunetable: Float32Array;
    vibratotable: Float32Array[];
    title?: string;
    signature?: string;
    songlen: number;
    repeatpos?: number;
    patterntable: Float32Array;
    channels: number;
    sample: {
        name: string;
        length: number;
        finetune: number;
        volume: number;
        loopstart: number;
        looplength: number;
        data: Float32Array;
    }[];
    samples: number;
    patterns: number;
    pattern: Uint8Array[];
    note?: Uint8Array[];
    pattern_unpack?: Uint8Array[];
    looprow: number;
    loopstart?: number;
    loopcount?: number;
    patterndelay?: number;
    patternwait: number;
    tick: number;
    position: number;
    row: number;
    offset: number;
    flags: number;
    speed: number;
    bpm: number;
    breakrow: number;
    patternjump: number;
    endofsong?: boolean;
    channel: {
        sample: number;
        period: number;
        voiceperiod: number;
        note: number;
        volume: number;
        command: number;
        data: number;
        samplepos: number;
        samplespeed: number;
        flags: number;
        noteon: number;
        slidespeed: number;
        slideto: number;
        slidetospeed: number;
        arpeggio: number;
        semitone: number;
        vibratospeed: number;
        vibratodepth: number;
        vibratopos: number;
        vibratowave: number;
    }[];
    chvu: Float32Array;
    constructor();
    clearsong(): void;
    initialize(): void;
    parse(buffer: Uint8Array): boolean;
    mix(bufs: Float32Array[], buflen: number): void;
    advance(): void;
    play(): void;
    pause(): void;
}
